--TODO: Pretty Ui
--TODO: Game mode change
--TODO: Splash screen before game start
--TODO: Custom splash screen using my love2d avatar ?
--TODO: Smoother graphics (again)
--TODO: Neaten code if needed
--TODO: Sounds
--TODO: UI transitions
--TODO: Add more settings when needed
--TODO: load game before activating it to make things soother allowing transitions with "NO LAG!!!" :D
--TODO: UI effects

local Beat = require "Beat-D"

local Selector, Selector2, Max_options
local A1, A2, A3, A4, A5, A6
local Menustate
local screen_width, screen_height
local Left, Right, Center, CenterB
local RESnum, Res
local canvas
local width, height
local fade, fadeVol

------------------------ [ This handles the menu options ] ------------------------
RESnum = 1
Res = "Windowed"
screen_width, screen_height = love.window.getDesktopDimensions()
canvas = love.graphics.newCanvas(love.graphics.getHeight(), love.graphics.getWidth())

------------------------ [ This handles the screen ] ------------------------
width, height = love.graphics.getWidth(), love.graphics.getHeight()
love.window.setMode(screen_width / 2, screen_height / 2 + screen_width / 6)

Selector = 1
Selector2 = 1
A1 = 40
A2 = 20
A3 = 20
A4 = 20
A5 = 40
A6 = 20
------------------------ [ This creates Menu as a table ] ------------------------
local Menu = { Active = 1,
               Select = "Exit",
               gridXCount = 40,
               gridYCount = 40,
               cellSize = 15
               }

------------------------ [ This creates Music as a table ] ------------------------
local Music = {AllowStart = 0,
               FileC = 0,
               FileCH = 0,
               Playlist = {}
              }

Music.text = {}
Music.text[0] = "No Music"

Music.Playlist[0] = Beat:newSource("BLANK.wav")

------------------------ [ This "clamps" a variable ] ------------------------
function math.clamp(val, min, max)
    if min > max then
        min, max = max, min
    end

    return math.max(min, math.min(max, val))
end

------------------------ [ This "fades" an audio variable ] ------------------------
local function Fade(source, time)
    fade = true
    
    source, time = source, time
    
    return source, time, fade
end

------------------------ [ This loads the menu ] ------------------------
function Menu.load()
    width, height = love.graphics.getWidth(), love.graphics.getHeight()
    
    Menu.squareColumns = math.floor(height / 14)
    Menu.squareRows = math.floor(width / 14)
    
    love.graphics.setCanvas()
    
    love.graphics.setColor(255, 255, 255)
    
    love.mouse.setVisible(false)
    
    Menu.font = love.graphics.newFont('PixelFJVerdana12pt_0.ttf', 20)
    Menu.fontS = love.graphics.newFont('PixelFJVerdana12pt_0.ttf', 14)
    Menu.fontSs = love.graphics.newFont('PixelFJVerdana12pt_0.ttf', 12)
    love.graphics.setFont(Menu.font)
    
    Menustate = "Menu"
    
    Left = {}
    Left.text = love.graphics.newText(Menu.font, "<")
    Left.x = 360
    Left.y = 120
    
    Right = {}
    Right.text = love.graphics.newText(Menu.font, ">")
    Right.x = 520
    Right.y = 120
    
    Left.x2 = love.graphics.getWidth()/2 - 180
    Left.y2 = love.graphics.getHeight()/2 + 80
    
    Right.x2 = love.graphics.getWidth()/2 + 160
    Right.y2 = love.graphics.getHeight()/2 + 80
    
    Center = {}
    Center.text = love.graphics.newText(Menu.font, "Remove")
    
    Center.x = love.graphics.getWidth()/2 - 80
    Center.y = love.graphics.getHeight()/2 + 220
    
    CenterB = {}
    CenterB.text = love.graphics.newText(Menu.font, "Preview Song")
    
    CenterB.x = love.graphics.getWidth()/2 - 120
    CenterB.y = love.graphics.getHeight()/2 + 150
    
    Menu.Snake = { x = 100,
          y = 500,
          w = 20,
          h = 20,
          direction = "right",
          speed = 1,
          cellSize = 15,
          Alive = true,
          R = 0,
          G = 255,
          B = 0,
          move = true,
          Segments = {
              { x = 3, y = 1 },
              { x = 2, y = 1 },
              { x = 1, y = 1 }
          }
    }
    
    fade = false
    fadeVol = 1
end

------------------------ [ This updates the menu ] ------------------------
function Menu.update()
    if fade == true and fadeVol ~= 0 then
        fadeVol = fadeVol - 0.1
    else
        fade = false
        fadeVol = 1
    end
    
    if Music.FileCH ~= 0 then
        --Music.Playlist[Music.FileCH]:setVolume(love.timer.getTime()/)
    end
end

------------------------ [ This checks if the mouse is pressed ] ------------------------

function Menu.mousereleased(x, y, button)
    
    ---- [ settings button handling ] ----
    if button == 1 then
        if x >= Left.x and x <= Left.x + Left.text:getWidth() and y >= Left.y and y <= Left.y + Left.text:getHeight() then
            RESnum = RESnum + 1
        end
        
        if x >= Right.x and x <= Right.x + Right.text:getWidth() and y >= Right.y and y <= Right.y + Right.text:getHeight() then
            RESnum = RESnum - 1
        end
        
        if RESnum == 3 then
            RESnum = 1
        end
        
        if RESnum == 0 then
            RESnum = 2
        end
        
        if RESnum == 1 then
            Res = "Windowed"
        end
        if RESnum == 2 then
            Res = "Fullscreen"
        end
        
        ---- [ music button handling ] ----
        
        if x >= Left.x2 and
            x <= Left.x2 + Left.text:getWidth() and
            y >= Left.y2 and
            y <= Left.y2 + Left.text:getHeight() then
            
            if Music.FileCH ~= 0 then
                love.audio.stop(Music.Playlist[Music.FileCH])
                
                Music.FileCH = math.clamp(Music.FileCH - 1, 1, Music.FileC)
            end
        end
        
        if x >= Right.x2 and
            x <= Right.x2 + Right.text:getWidth() and
            y >= Right.y2
            and y <= Right.y2 + Right.text:getHeight() then
            
            if Music.FileCH ~= 0 then
                love.audio.stop(Music.Playlist[Music.FileCH])
                Fade(Music.Playlist[Music.FileCH], 1)
                Music.FileCH = math.clamp(Music.FileCH + 1, 1, Music.FileC)
            end
        end
        
        if x >= Center.x and
            x <= Center.x + Center.text:getWidth() and
            y >= Center.y
            and y <= Center.y + Center.text:getHeight() then
            
            if Music.FileCH ~= 0 then
                love.audio.stop(Music.Playlist[Music.FileCH])
                table.remove(Music.Playlist, Music.FileCH)
                
                Music.FileC = Music.FileC - 1
                Music.FileCH = math.clamp(Music.FileCH - 1, 1, Music.FileC)
            end
        end
        
        if x >= CenterB.x and
            x <= CenterB.x + CenterB.text:getWidth() and
            y >= CenterB.y
            and y <= CenterB.y + CenterB.text:getHeight() then
                love.audio.play(Music.Playlist[Music.FileCH])
        end
    end
end

------------------------ [ This checks if a key is pressed ] ------------------------

function Menu.keypressed(key)
    if Menustate ~= "settings" then
        
        Max_options = 4
        
        if key == 'down' or key == 's' then
            Selector = Selector + 1
            if Selector > Max_options then
                Selector = 1
            end
        
        elseif key == 'up' or key == 'w' then
            Selector = Selector - 1
            if Selector < 1 then
                Selector = Max_options
            end
        
        elseif key == 'return' then
            if Menustate == "Menu" then
                
                if Selector == 1 and Music.AllowStart == 1 then
                    Menu.Active = 0
                end
                
                if Selector == 2 then
                    Menustate = "music"
                    love.mouse.setVisible(true)
                    love.graphics.clear()
                    
                    if Music.FileC > 0 then
                        love.audio.play(Music.Playlist[Music.FileCH])
                    end
                end
                
                if Selector == 3 then
                    Menustate = "settings"
                    love.mouse.setVisible(true)
                    love.graphics.clear()
                end
                
                if Selector == 4 then
                    love.event.quit()
                end
            
            end
        end
        
        if Selector == 1 then
            A1 = 40
        else
            A1 = 20
        end
        
        if Selector == 2 then
            A2 = 40
        else
            A2 = 20
        end
        
        if Selector == 3 then
            A3 = 40
        else
            A3 = 20
        end
        
        if Selector == 4 then
            A4 = 40
        else
            A4 = 20
        end
    else
        
        Max_options = 2
        
        if key == 'down' or key == 's' then
            Selector2 = Selector2 + 1
            if Selector2 > Max_options then
                Selector2 = 1
            end
        
        elseif key == 'up' or key == 'w' then
            Selector2 = Selector2 - 1
            if Selector2 < 1 then
                Selector2 = Max_options
            end
        
        elseif key == 'return' then
            if Selector2 == 1 then
                love.graphics.clear()
                love.graphics.setCanvas()
                love.window.setMode(Menu.gridXCount, Menu.gridYCount)
            end
            
            if Selector2 == 2 then
                Menu.load()
            end
        end
        
        if Selector2 == 1 then
            A5 = 40
        else
            A5 = 20
        end
        
        if Selector2 == 2 then
            A6 = 40
        else
            A6 = 20
        end
    end
    
    if Menustate == "music" then
        if key == 'escape' then
            love.graphics.clear()
            love.audio.stop(Music.Playlist[Music.FileCH])
            Menu.load()
        end
    end
end


------------------------ [ This draws the menu ] ------------------------

function Menu.draw()
    if Menu.Active == 1 then
        if Menustate == "settings" then
            love.graphics.setBackgroundColor(0, 0, 0)
            
            love.graphics.setLineWidth(4)
            love.graphics.setColor(254, 67, 101)
            
            love.graphics.setColor(255, 0, 0)
            love.graphics.rectangle("line", 400, 55, screen_width / Menu.Snake.cellSize + 10, screen_height / Menu.Snake.cellSize + 10)
            love.graphics.setColor(255, 255, 255)
            
            love.graphics.setFont(Menu.fontS)
            
            if RESnum == 2 then
                love.graphics.setFont(Menu.font)
                love.graphics.printf("Fullscreen", 360, 10, 400)
                love.graphics.setFont(Menu.fontS)
                love.graphics.printf(tostring(Res), 390, 127, 400)
                love.graphics.setFont(Menu.font)
                
                love.graphics.setColor(255, 255, 255)
                love.graphics.rectangle("line", 405, 60, screen_width / Menu.Snake.cellSize, screen_height / Menu.Snake.cellSize)
            elseif RESnum == 1 then
                love.graphics.setFont(Menu.font)
                love.graphics.printf("Windowed", 360, 10, 400)
                love.graphics.setFont(Menu.fontS)
                love.graphics.printf(tostring(Res), 385, 127, 400)
                
                love.graphics.setColor(255, 255, 255)
                love.graphics.rectangle("line", 405, 60, screen_width / Menu.Snake.cellSize / 2, screen_height / Menu.Snake.cellSize / 2)
            end
            
            if Res == "Windowed" then
                Menu.gridXCount = screen_width / 2
                Menu.gridYCount = screen_height / 2 + screen_width / 6
                
                love.graphics.setFont(Menu.font)
                love.graphics.printf(tostring(math.floor(screen_height / 2)), 10, 50, 400)
                love.graphics.printf(tostring(math.floor(screen_width / 2)), 10, 150, 400)
            elseif Res == "Fullscreen" then
                Menu.gridXCount = screen_width
                Menu.gridYCount = screen_height
                
                love.graphics.setFont(Menu.font)
                love.graphics.printf(tostring(math.floor(screen_height)), 10, 50, 400)
                love.graphics.printf(tostring(math.floor(screen_width)), 10, 150, 400)
            end
            
            love.graphics.setFont(Menu.font)
            
            love.graphics.printf("Screen Width", 10, 10, 400)
            love.graphics.printf("Screen Height", 10, 100, 400)
            
            love.graphics.draw(Right.text, Right.x, Right.y)
            love.graphics.draw(Left.text, Left.x, Left.y)
            
            love.graphics.printf("Apply Changes", A5, love.graphics.getHeight() - 110, 400)
            love.graphics.printf("Exit", A6, love.graphics.getHeight() - 50, 400)
        
            
        elseif Menustate == "music" then
            
            love.graphics.printf("Drag and drop music here to add it to your playlist!", love.graphics.getWidth()/2 - 200, love.graphics.getHeight() - 600, 400, "center")
            
            love.graphics.setFont(Menu.fontSs)
            love.graphics.printf(Music.text[Music.FileCH], love.graphics.getWidth()/2 - 200, love.graphics.getHeight() - 400, 400, "center")
            love.graphics.setFont(Menu.font)
            
            love.graphics.printf("File "..Music.FileCH, love.graphics.getWidth()/2 - 200, Left.y2, 400, "center")
            
            love.graphics.draw(Right.text, Right.x2, Right.y2)
            love.graphics.draw(Left.text, Left.x2, Left.y2)
            love.graphics.draw(CenterB.text, CenterB.x, CenterB.y)
            
            love.graphics.setColor(255, 0, 0)
            love.graphics.draw(Center.text, Center.x, Center.y)
            love.graphics.setColor(255, 255, 255)
        else
            if Music.AllowStart == 0 then
                love.graphics.setColor(255,0,0)
            else
                love.graphics.setColor(255,255,255)
            end
            
            love.graphics.printf("Begin", A1, 10, 200)
            
            love.graphics.setColor(255,255,255)
            
            love.graphics.printf("Music", A2, 110, 200)
            love.graphics.printf("Settings", A3, 210, 200)
            love.graphics.printf("Exit", A4, 310, 200)
        end
    else
        love.graphics.clear()
    end
end

function Menu.filedropped(file)
    if Menustate == "music" then
        Music.AllowStart = 1
        
        Music.FileC = Music.FileC + 1
        Music.FileCH = Music.FileC
        Music.FileCPrev = Music.FileC - 1
        
        Music.soundData = love.sound.newSoundData(file)
        Music.Music = love.audio.newSource(Music.soundData)
        
        if Music.FileC > 1 then
            love.audio.stop(Music.Playlist[Music.FileCPrev])
        end
        
        Music.Playlist[Music.FileC] = Music.Music
        
        Music.text[Music.FileC] = file:getFilename()
        
        return Music.Music, Music.Playlist
    end
end


return Menu, Music, Music.Playlist





